
/*
    Operación de ejemplo: 
              0x20 + ((0x40 + 0x35) * 0x100) - 0x200 -> r0
*/
   .text
main:
   mov  r2,#0x20
   mov  r1,#0x40
   mov  r0,#0x35
   push {r0,r1,r2} @ apila, en orden, 0x20, 0x40, y finalmente 0x35
 
   bl   sumap      @ suma
   ldr  r0,=#0x100
   push {r0}       @  apila 0x100

   bl   multp      @ multiplica
   bl   sumap

   ldr  r0,=#0x200
   push {r0}       @  apila 0x200

   bl   swapp      @ swap
   bl   restap     @ resta

   pop  {r0}       @  desapila: resultado a r0

   wfi

   
/*
 sumap:   Suma las dos palabras en la cima de la pila 
 y las sustituye por el resultado de la suma. Los 
 indicadores se activan en función del resultado de la suma.
    
*/
sumap:
   pop   {r0, r1}   @ cargamos los datos   
   add   r0,r0,r1   @ hacemos la suma, modificando flags
   push  {r0}       @ almacenamos el resultado (no modifica flags)
   mov   pc,lr      @ volvemos


/*
restap:   Resta las dos palabras en la cima de la pila y 
   las sustituye por el resultado de la suma. Los 
   indicadores se activan de acuerdo con el resultado de la resta.

*/
restap:
   pop   {r0, r1}   @ cargamos los datos   
   sub   r0,r0,r1   @ hacemos la resta, modificando flags
   push  {r0}       @ almacenamos el resultado (no modifica flags)
   mov   pc,lr      @ volvemos

/*
multp:   Multiplica las dos medias palabras menos significativas 
   de las dos palabras en la cima de la pila, y las 
   sustituye por el resultado (una palabra). Los indicadores se activan
   de acuerdo con el resultado de la multiplicación.

*/
multp:
   pop   {r0, r1}   @ cargamos los datos   
   mul   r0,r0,r1   @ hacemos la multiplicación, modificando flags
   push  {r0}       @ almacenamos el resultado (no modifica flags)
   mov   pc,lr      @ volvemos

/*
swapp:   Intercambia las dos palabras en la cima de la pila.

   Si la pila está vacía o si solo hay un dato, no hace nada.
*/
swapp:
   ldr   r0,[sp,#0]    @ cargamos el primer dato
   mov   r1,r0
   ldr   r0,[sp,#4]    @ cargamos el segundo dato
   str   r0,[sp,#0]    @ lo ponemos en el lugar del primero
   str   r1,[sp,#4]      
   mov   pc,lr
   .end