      .data
nums: .hword 1, 2, -3, 16, -5, 6, 7, -32, 9, 10, 11, 64

      .text
      ldr r4,=nums     @ r4: dirección de comienzo de la zona de números
      sub sp,#24       @ reservamos espacio en la pila para los números
      mov r5,sp        @ r5: dirección de la cima dela pila
      mov r6,#22       @ r6: contador (inicializado a (12 - 1) * 2 bytes)
buc:  ldrh r7,[r4,r6]  @ r7: cargamos un número de la zona
      strh r7,[r5,r6]  @ y lo dejamos en su sitio en la pila
      cmp  r6,#0       @ vemos si hemos terminado 
      beq  csp
      sub  r6,#2       @ si no, actualizamos el contador
      b buc            @ y repetimos con la siguiente media palabra
csp:  bl mul16
      pop {r0-r5}
      wfi

/*
 mul16: a partir de una lista de 12 números de 16 bits 
   en la pila, sustituye por un cero los números que 
   son múltiplo de 16.

*/
mul16:
      mov r0,sp           @ r0: puntero a los números          
      ldr r1,=12          @ r1: contador 
      mov r2,#0x0000000f  @ r2: máscara para comprobar 

bucs: ldrh r3,[r0]        @ r3: número a comprobar (16 bits)
      and r3,r3,r2        @ dejamos los 4 bits menos significativos
      bne nomul           @ si son 0, era múltiplo de 16
      strh r3,[r0]        @ reemplazamos por un cero

nomul:
      sub r1,r1,#1        @ actualizamos puntero y contador
      beq fins
      add r0,r0,#2
      b bucs

fins: mov pc,lr
      .end
